'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _certVerifierJs = require('cert-verifier-js');

var _reactTimestamp = require('react-timestamp');

var _reactTimestamp2 = _interopRequireDefault(_reactTimestamp);

var _reactJsonView = require('react-json-view');

var _reactJsonView2 = _interopRequireDefault(_reactJsonView);

var _styles = require('@material-ui/core/styles');

var _core = require('@material-ui/core');

var _blockcertsLogo = require('./data/blockcertsLogo');

var _blockcertsLogo2 = _interopRequireDefault(_blockcertsLogo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  wrapper: {
    marginTop: 0,
    marginBottom: 0,
    marginLeft: 'auto',
    marginRight: 'auto',
    maxWidth: 992
  },
  header: {
    paddingTop: 20,
    textAlign: 'center'
  },
  tab: {
    padding: 20
  },
  tabs: {
    marginTop: 10
  },
  image: {
    maxWidth: '100%',
    height: 'auto',
    marginBottom: 20
  },
  stepper: {
    textAlign: 'left'
  },
  stepButtons: {
    marginTop: 20
  },
  stepButton: {
    marginRight: 20
  },
  verifierResult: {
    textAlign: 'center'
  },
  verifierButton: {
    margin: 20
  },
  jsonContainer: {
    textAlign: 'left',
    fontSize: '10px',
    overflow: 'hidden'
  }
};

function TabContainer(props) {
  return _react2.default.createElement(
    _core.Typography,
    { component: 'div', style: { padding: 8 * 3 } },
    props.children
  );
}

TabContainer.propTypes = {
  children: _propTypes2.default.node.isRequired
};

var verifierSteps = [{
  status: 'computingLocalHash',
  name: 'Computing local hash',
  description: 'Compute locally the hash of this certificate.'
}, {
  status: 'fetchingRemoteHash',
  name: 'Fetching remote hash',
  description: 'Get the certificate hash stored in the blockchain transaction.'
}, {
  status: 'parsingIssuerKeys',
  name: 'Parsing issuer keys',
  description: 'Get the issuer blockchain public keys (actual and revoked).'
}, {
  status: 'comparingHashes',
  name: 'Comparing hashes',
  description: 'Compare the locally computed hash of this certificate VS the hash stored in the blockchain.'
}, {
  status: 'checkingMerkleRoot',
  name: 'Checking Merkle root',
  description: 'Validate the Merkle proof stored inside of the certificate.'
}, {
  status: 'checkingReceipt',
  name: 'Checking receipt',
  description: 'Compare the Merkle root value in the certificate with the value in the blockchain transaction.'
}, {
  status: 'checkingRevokedStatus',
  name: 'Checking revoked status',
  description: 'Check that this certificate has not been revoked by the issuer.'
}, {
  status: 'checkingAuthenticity',
  name: 'Checking authenticity',
  description: 'Check that the certificate was authored by the issuer.'
}, {
  status: 'checkingExpiresDate',
  name: 'Checking expires date',
  description: 'Check that the certificate is not expired.'
}, {
  status: 'success',
  name: 'Valid certificate',
  description: 'Success: this certificate is valid!'
}];

var Blockcerts = function (_Component) {
  _inherits(Blockcerts, _Component);

  function Blockcerts(props) {
    _classCallCheck(this, Blockcerts);

    var _this = _possibleConstructorReturn(this, (Blockcerts.__proto__ || Object.getPrototypeOf(Blockcerts)).call(this, props));

    _this.state = {
      tab: 0,
      certificateJson: null,
      certificate: null,
      verifierStep: 0,
      verifierFailureStep: null,
      verifierResult: null,
      viewJson: false
    };
    _this.tabChange = _this.tabChange.bind(_this);
    _this.verifyCertificate = _this.verifyCertificate.bind(_this);
    _this.verifierStepper = _this.verifierStepper.bind(_this);
    _this.verifierNext = _this.verifierNext.bind(_this);
    _this.verifierBack = _this.verifierBack.bind(_this);
    return _this;
  }

  _createClass(Blockcerts, [{
    key: 'componentDidMount',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var response, certificateJson, certificate;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;

                if (!this.props.url) {
                  _context.next = 11;
                  break;
                }

                _context.next = 4;
                return fetch(this.props.url);

              case 4:
                response = _context.sent;
                _context.next = 7;
                return response.json();

              case 7:
                certificateJson = _context.sent;

                this.setState({ certificateJson: certificateJson });
                _context.next = 13;
                break;

              case 11:
                _context.next = 13;
                return this.setState({ certificateJson: this.props.json });

              case 13:
                _context.next = 18;
                break;

              case 15:
                _context.prev = 15;
                _context.t0 = _context['catch'](0);

                console.error(_context.t0);

              case 18:
                certificate = _certVerifierJs.Certificate.parseJson(this.state.certificateJson);

                this.setState({ certificate: certificate });
                this.verifyCertificate();

              case 21:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 15]]);
      }));

      function componentDidMount() {
        return _ref.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: 'tabChange',
    value: function tabChange(event, value) {
      this.setState({ tab: value });
    }
  }, {
    key: 'verifyCertificate',
    value: function verifyCertificate() {
      var _this2 = this;

      if (this.state.certificateJson) {
        var verifier = new _certVerifierJs.CertificateVerifier(JSON.stringify(this.state.certificateJson), this.verifierStepper);
        verifier.verify().then(function (result) {
          return _this2.setState({ verifierResult: result });
        }).catch(function (e) {
          return console.error(e);
        });
      }
    }
  }, {
    key: 'verifierStepper',
    value: function verifierStepper(status) {
      if (status !== 'failure') {
        var _step = Object.keys(verifierSteps).find(function (key) {
          return verifierSteps[key].status === status;
        });
        this.setState({ verifierStep: _step });
      } else {
        this.setState({
          verifierFailureStep: this.state.verifierStep,
          verifierResult: 'failure'
        });
      }
    }
  }, {
    key: 'verifierNext',
    value: function verifierNext() {
      this.setState({ verifierStep: this.state.verifierStep + 1 });
    }
  }, {
    key: 'verifierBack',
    value: function verifierBack() {
      this.setState({ verifierStep: this.state.verifierStep - 1 });
    }
  }, {
    key: 'toggleDebug',
    value: function toggleDebug() {
      if (this.state.viewJson) {
        this.setState({ viewJson: false });
      } else {
        this.setState({ viewJson: true });
        console.log(this.state.certificateJson);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      if (this.state.certificateJson && this.state.certificate) {
        var tab = this.state.tab;
        var verifierStep = this.state.verifierStep;
        var verifierFailureStep = this.state.verifierFailureStep;

        return _react2.default.createElement(
          'div',
          { className: this.props.classes.wrapper },
          _react2.default.createElement(
            _core.Paper,
            { elevation: 4 },
            _react2.default.createElement(
              'div',
              {
                className: this.props.classes.header,
                style: {
                  color: this.props.color,
                  backgroundColor: this.props.color_bg
                }
              },
              _react2.default.createElement('img', { src: this.props.image }),
              _react2.default.createElement(
                _core.Tabs,
                {
                  className: this.props.classes.tabs,
                  value: tab,
                  onChange: this.tabChange,
                  indicatorColor: 'primary',
                  centered: true
                },
                _react2.default.createElement(_core.Tab, { label: 'View' }),
                _react2.default.createElement(_core.Tab, { label: 'Verify' })
              )
            ),
            tab === 0 && _react2.default.createElement(
              TabContainer,
              null,
              _react2.default.createElement(
                'div',
                { className: this.props.classes.tab },
                this.state.certificateJson.displayHtml && _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: this.state.certificateJson.displayHtml.replace(/(<? *script)/gi, 'illegalscript') } }),
                !this.state.certificateJson.displayHtml && _react2.default.createElement(
                  'div',
                  null,
                  _react2.default.createElement('img', { src: this.state.certificate.certificateImage, className: this.props.classes.image }),
                  _react2.default.createElement(
                    _core.Typography,
                    { paragraph: true, variant: 'headline', component: 'h1' },
                    this.state.certificate.title
                  ),
                  _react2.default.createElement(
                    _core.Typography,
                    { paragraph: true, variant: 'subheading', component: 'h2' },
                    this.state.certificate.subtitle
                  ),
                  _react2.default.createElement(
                    _core.Typography,
                    { paragraph: true, variant: 'caption', component: 'p' },
                    'Awarded on ',
                    _react2.default.createElement(_reactTimestamp2.default, { time: this.state.certificateJson.issuedOn.toString(), format: 'full' }),
                    ' to'
                  ),
                  _react2.default.createElement(
                    _core.Typography,
                    { paragraph: true, variant: 'title', component: 'h2' },
                    this.state.certificate.name
                  ),
                  _react2.default.createElement(
                    _core.Typography,
                    { paragraph: true, component: 'p' },
                    this.state.certificate.description
                  ),
                  _react2.default.createElement(
                    _core.Typography,
                    { paragraph: true, variant: 'caption', component: 'p' },
                    'Issued by'
                  ),
                  _react2.default.createElement('img', { src: this.state.certificate.sealImage, className: this.props.classes.image }),
                  _react2.default.createElement(
                    _core.Typography,
                    { paragraph: true, variant: 'title', component: 'h2' },
                    this.state.certificate.issuer.name
                  ),
                  _react2.default.createElement(
                    _core.Typography,
                    { paragraph: true, component: 'p' },
                    this.state.certificate.issuer.description
                  ),
                  _react2.default.createElement(
                    _core.Typography,
                    { paragraph: true, component: 'p' },
                    this.state.certificate.issuer.email
                  )
                )
              )
            ),
            tab === 1 && _react2.default.createElement(
              TabContainer,
              null,
              _react2.default.createElement(
                'div',
                { className: this.props.classes.verifierResult },
                _react2.default.createElement(
                  _core.Typography,
                  { variant: 'headline', component: 'h3' },
                  this.state.verifierResult === 'success' ? 'Valid certificate' : 'Invalid certificate'
                ),
                _react2.default.createElement(
                  _core.Typography,
                  { component: 'p' },
                  this.state.verifierResult === 'success' ? 'All the verification steps succedded. This certificate is valid!' : 'Some verification steps did not succeed. This certificate is NOT valid.'
                ),
                _react2.default.createElement(
                  _core.Button,
                  { className: this.props.classes.verifierButton, variant: 'contained', color: 'primary', onClick: this.verifyCertificate },
                  'Verify'
                ),
                _react2.default.createElement(
                  _core.Button,
                  { className: this.props.classes.verifierButton, variant: 'contained', color: 'primary', href: this.state.certificate.transactionLink },
                  'See blockchain transaction'
                ),
                _react2.default.createElement(
                  _core.Button,
                  {
                    className: this.props.classes.verifierButton,
                    variant: 'contained',
                    onClick: this.toggleDebug.bind(this) },
                  'Raw data'
                )
              ),
              this.state.viewJson && _react2.default.createElement(
                'div',
                { className: this.props.classes.jsonContainer },
                _react2.default.createElement(
                  _core.Typography,
                  { paragraph: true, component: 'p' },
                  'Data is logged in the browser console, too.'
                ),
                _react2.default.createElement(_reactJsonView2.default, {
                  src: this.state.certificateJson,
                  collapsed: true
                })
              ),
              _react2.default.createElement(
                'div',
                { className: this.props.classes.stepper },
                _react2.default.createElement(
                  _core.Stepper,
                  {
                    activeStep: parseInt(verifierStep),
                    orientation: 'vertical' },
                  verifierSteps.map(function (step, index) {
                    return _react2.default.createElement(
                      _core.Step,
                      { key: index },
                      _react2.default.createElement(
                        _core.StepLabel,
                        null,
                        step.name
                      ),
                      _react2.default.createElement(
                        _core.StepContent,
                        null,
                        _react2.default.createElement(
                          _core.Typography,
                          null,
                          step.description
                        ),
                        _react2.default.createElement(
                          'div',
                          { className: _this3.props.classes.stepButtons },
                          verifierStep > 0 && _react2.default.createElement(
                            _core.Button,
                            {
                              size: 'small',
                              color: 'secondary',
                              className: _this3.props.classes.stepButton,
                              onClick: _this3.verifierBack
                            },
                            'Back'
                          ),
                          verifierStep < verifierSteps.length - 1 && (!verifierFailureStep || verifierStep < verifierFailureStep) && _react2.default.createElement(
                            _core.Button,
                            {
                              size: 'small',
                              color: 'secondary',
                              className: _this3.props.classes.stepButton,
                              onClick: _this3.verifierNext
                            },
                            'Next'
                          )
                        )
                      )
                    );
                  })
                )
              )
            )
          )
        );
      } else {
        return null;
      }
    }
  }]);

  return Blockcerts;
}(_react.Component);

Blockcerts.defaultProps = {
  color: 'white',
  color_bg: '#02112a',
  image: _blockcertsLogo2.default
};

Blockcerts.propTypes = {
  url: _propTypes2.default.string,
  json: _propTypes2.default.object,
  image: _propTypes2.default.string,
  color: _propTypes2.default.string,
  color_bg: _propTypes2.default.string
};

exports.default = (0, _styles.withStyles)(styles)(Blockcerts);