'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('@material-ui/core/styles');

var _core = require('@material-ui/core');

var _reactTimestamp = require('react-timestamp');

var _reactTimestamp2 = _interopRequireDefault(_reactTimestamp);

var _blockcertsLogo = require('./data/blockcertsLogo');

var _blockcertsLogo2 = _interopRequireDefault(_blockcertsLogo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  wrapper: {
    marginTop: 0,
    marginBottom: 0,
    marginLeft: 'auto',
    marginRight: 'auto',
    maxWidth: 992
  },
  paper: {},
  header: {
    color: 'white',
    paddingTop: 20,
    paddingBottom: 20
  },
  image: {
    maxWidth: '100%',
    height: 'auto',
    marginBottom: 20
  }
};

var BlockcertsPreview = function (_Component) {
  _inherits(BlockcertsPreview, _Component);

  function BlockcertsPreview() {
    _classCallCheck(this, BlockcertsPreview);

    return _possibleConstructorReturn(this, (BlockcertsPreview.__proto__ || Object.getPrototypeOf(BlockcertsPreview)).apply(this, arguments));
  }

  _createClass(BlockcertsPreview, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: this.props.classes.wrapper },
        _react2.default.createElement(
          _core.Paper,
          { className: this.props.classes.paper, elevation: 4 },
          _react2.default.createElement(
            'div',
            {
              className: this.props.classes.header,
              style: { backgroundColor: this.props.color_bg }
            },
            _react2.default.createElement('img', { src: this.props.image })
          ),
          this.props.json.displayHtml && _react2.default.createElement(
            'div',
            { className: this.props.classes.tab },
            _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: this.props.json.displayHtml.replace(/(<? *script)/gi, 'illegalscript') } })
          ),
          !this.props.json.displayHtml && _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement('img', { src: this.props.json.badge.image, className: this.props.classes.image }),
            _react2.default.createElement(
              _core.Typography,
              { paragraph: true, variant: 'headline', component: 'h1' },
              this.props.json.title
            ),
            _react2.default.createElement(
              _core.Typography,
              { paragraph: true, variant: 'subheading', component: 'h2' },
              this.props.json.badge.name
            ),
            _react2.default.createElement(
              _core.Typography,
              { paragraph: true, variant: 'caption', component: 'p' },
              'Awarded on ',
              _react2.default.createElement(_reactTimestamp2.default, { time: this.props.json.issuedOn.toString(), format: 'full' }),
              ' to'
            ),
            _react2.default.createElement(
              _core.Typography,
              { paragraph: true, variant: 'title', component: 'h2' },
              this.props.json.recipientProfile.name
            ),
            _react2.default.createElement(
              _core.Typography,
              { paragraph: true, variant: 'caption', component: 'p' },
              'Issued by'
            ),
            _react2.default.createElement('img', { src: this.props.json.badge.issuer.image, className: this.props.classes.image }),
            _react2.default.createElement(
              _core.Typography,
              { paragraph: true, variant: 'title', component: 'h2' },
              this.props.json.badge.issuer.name
            ),
            _react2.default.createElement(
              _core.Typography,
              { paragraph: true, component: 'p' },
              this.props.json.badge.issuer.email
            )
          )
        )
      );
    }
  }]);

  return BlockcertsPreview;
}(_react.Component);

BlockcertsPreview.defaultProps = {
  color_bg: '#02112a',
  image: _blockcertsLogo2.default
};

BlockcertsPreview.propTypes = {
  json: _propTypes2.default.object.isRequired,
  image: _propTypes2.default.string,
  color_bg: _propTypes2.default.string
};

exports.default = (0, _styles.withStyles)(styles)(BlockcertsPreview);